MapMercator={}

MapMercator.TILE_SIZE = 256
MapMercator.MAX_LAT = 85.05112877980659
MapMercator.MIN_LAT = -85.05112877980659

MapMercator.radius=function(aZoomlevel)
   return MapMercator.TILE_SIZE * math.pow(2,aZoomlevel) / (2.0 * math.pi)
end

MapMercator.getMaxPixels=function(aZoomlevel)
        return MapMercator.TILE_SIZE * math.pow(2,aZoomlevel)
end

MapMercator.falseEasting=function(aZoomlevel)
        return MapMercator.getMaxPixels(aZoomlevel) / 2
end

MapMercator.falseNorthing=function(aZoomlevel)
        return (-1 * MapMercator.getMaxPixels(aZoomlevel) / 2)
end
MapMercator.LonToX=function(aLongitude, aZoomlevel) 
        mp = MapMercator.getMaxPixels(aZoomlevel)
        x = ((mp * (aLongitude + 180)) / 360)
        x = math.min(x, mp - 1)
        return x
end
MapMercator.LatToY=function(aLat,aZoomlevel)
        if (aLat < MapMercator.MIN_LAT) then
            aLat = MapMercator.MIN_LAT
        elseif (aLat > MapMercator.MAX_LAT) then
            aLat = MapMercator.MAX_LAT;
		end
        sinLat = math.sin(math.pi*aLat/180)
        mlog = math.log((1.0 + sinLat) / (1.0 - sinLat))
        mp = MapMercator.getMaxPixels(aZoomlevel)
        y = (mp * (0.5 - (mlog / (4.0 * math.pi))))
        y = math.min(y, mp - 1)
        return y
end
MapMercator.XToLon=function(aX,aZoomlevel)
        return ((360.0 * aX) / MapMercator.getMaxPixels(aZoomlevel)) - 180.0
end

MapMercator.YToLat=function(aY,aZoomlevel)
        aY = aY+ MapMercator.falseNorthing(aZoomlevel)
        latitude = (math.pi / 2) - (2 * math.atan(math.exp(-1.0 * aY / MapMercator.radius(aZoomlevel))))
        return -180.0*latitude/math.pi
end
